#include "Asm86.h"                  ;flags, key equates...
#include "Ram86.h"                  ;memory locations
#include "Rom86.h"                  ;ROM calls

.plugin lite86;                     ;the ultimate compression rutine

_ioprompt   =$c324                  ;\
_asap_ind   =$d623                  ; > Not included in includes!
_getcode    =$4068                  ;/

.org _asm_exec_ram 

    nop                             ;no operation so...
    jp Start                        ;jump to Start
    .dw 0                           ;type of input
    .dw String1                     ;print string

String1:    .db "Pythagorean Theorem",0

Start:
    xor a                           ;clears value of a, set to 0
    call _setXXop1                  ;moves value @ a to op1
    call _stoY                      ;op1(0) ==> real variable (y)
    call _stoX                      ;op1(0) ==> real variable (x)
    call _op1toop6                  ;op1(0) ==> op6
InputStart:
    call _flushallmenus             ;clears all key codes
    call _runindicon                ;turn off run indicator
    call _clrScrn                   ;clears the lcd and graph screen
    ld hl,(256*1)+3                 ;loads coordinates into hl
    ld (_curRow),hl                 ;loads _curRow with hl
    ld hl,String1                   ;loads hl with string
    call _puts                      ;print string
    ld hl,String2                   ;string to print
    ld bc,256*58+12                 ;column 5, row 59
    ld (_penCol),bc                 ;loads c into _penCol
    call _vputs                     ;print it and return
    ld hl,String3                   ;string to print
    ld bc,256*58+37                 ;column 5, row 59
    ld (_penCol),bc                 ;loads c into _penCol
    call _vputs                     ;print it and return
    ld hl,String4                   ;string to print
    ld bc,256*58+61                 ;column 5, row 59
    ld (_penCol),bc                 ;loads c into _penCol
    call _vputs                     ;print it and return
    ld hl,String5                   ;string to print
    ld bc,256*58+79                  ;column 5, row 59
    ld (_penCol),bc                 ;loads c into _penCol
    call _vputs                     ;print it and return
    call MenuRoutine2               ;goes to MenuRoutine2
GetKey1:
    call _getcode                   ;stores key pressed into a
    cp K_EXIT                       ;compares a with EXIT
    jp z,Exit                       ;if EXIT jump to Exit
    cp K_F1                         ;compares a with F1
    jr z,Input_a                    ;if F1 jump to Input_a
    cp K_F2                         ;compares a with F2
    jr z,Input_b                    ;if F2 jump to Input_b
    cp K_F3                         ;compares a with F3
    jr z,Input_c                    ;if F2 jump to Input_c
    cp K_F4                         ;compares a with F4
    jp z,Solve                      ;if F2 jump to Solve
    cp K_F5                         ;compares a with F5
    jp z,Back                       ;if F2 jump to Back
    cp K_MORE                       ;compares a with MORE
    jr z,ExitMenu                   ;if MORE jump to Start
    jr GetKey1                      ;relative jump to GetKey1

ExitMenu:
    call _clrScrn                   ;clears the lcd and graph screen
    ld hl,(256*1)+3                 ;loads coordinates into hl
    ld (_curRow),hl                 ;loads _curRow with hl
    ld hl,String1                   ;loads hl with string
    call _puts                      ;print string
    ld hl,String6                   ;string to print
    ld bc,256*58+8                  ;column 5, row 59
    ld (_penCol),bc                 ;loads c into _penCol
    call _vputs                     ;print it and return
    call MenuRoutine1               ;goes to MenuRoutine1
GetKey2:
    call _getcode                   ;stores key pressed into a
    cp K_EXIT                       ;compares a with EXIT
    jp z,Exit                       ;if EXIT jump to Exit
    cp K_F1                         ;compares a with F1
    jp z,Exit                       ;if F1 jump to Exit
    cp K_MORE                       ;compares a with MORE
    jp z,Start                      ;if MORE jump to Start
    jr GetKey2                      ;relative jump to GetKey1

Input_a:
    call Text1                      ;goes to Text1
    ld hl,E1                        ;string to print
    call Input                      ;goes to Input
    call _stoX                      ;op1 ==> real variable (x)
    ld c,1                          ;loads c with 1
    call _ckop1pos                  ;check to see if op1 is positive
    jp nz,Negative                  ;if op1 is not positive jump to NoSolutions
    jp InputStart                   ;jump to InputStart

Input_b:
    call Text1                      ;goes to Text1
    ld hl,E2                        ;string to print
    call Input                      ;goes to Input
    call _stoY                      ;op1 ==> real variable (y)
    ld c,2                          ;loads c with 2
    call _ckop1pos                  ;check to see if op1 is positive
    jp nz,Negative                  ;if op1 is not positive jump to NoSolutions
    jp InputStart                   ;jump to InputStart

Input_c:
    call Text1                      ;goes to Text1
    ld hl,E3                        ;string to print
    call Input                      ;goes to Input
    call _op1toop6                  ;op1 ==> op6
    ld c,3                          ;loads c with 3
    call _ckop1pos                  ;check to see if op1 is positive
    jp nz,Negative                  ;if op1 is not positive jump to NoSolutions
    jp InputStart                   ;jump to InputStart

Solve:
    call _rclX                      ;recall real variable x(a) to op1
    rst 08h                         ;op1(a) is copied to op2
    xor a                           ;reset a to 0
    call _setXXop1                  ;move value of a(0) to op1
    call _cpop1op2                  ;compare op1 and op2
    jr z,Solve_a                    ;if op1 is 0 jump to Solve_a
    call _rclY                      ;recall real variable y(b) to op1
    rst 08h                         ;op1(b) is copied to op2
    xor a                           ;load a with 0
    call _setXXop1                  ;move value of a(0) to op1
    call _cpop1op2                  ;compare op1 and op2
    jp z,Solve_b                    ;if op1 is 0 jump to Solve_b
    call _op6toop1                  ;op6(c) ==> op1
    rst 08h                         ;op1(c) is copied to op2
    xor a                           ;load a with 0
    call _setXXop1                  ;move value of a(0) to op1
    call _cpop1op2                  ;compare op1 and op2
    jp z,Solve_c                    ;if op1 is 0 jump to Solve_c

Solve_a:
    call ScreenDisplay              ;goes to ScreenDisplay
    call _rclY                      ;recall real variable (b) to op1
    call _FPSQUARE                  ;op1(b) ^2 ==> op1
    call _op1toop4                  ;op1(b^2) ==> op4
    call _op6toop1                  ;op6(c) ==> op1
    call _FPSQUARE                  ;op1(c) ^2 ==> op1
    call _op4toop2                  ;op4(b^2) ==> op2
    call _FPSUB                     ;op1(c^2) - op2(b^2) ==> op1
    ld hl,String10                  ;string to print
    ld bc,256*31+4                  ;column 0, row 0
    ld (_penCol),bc                 ;loads c into _penCol
    call _vputs                     ;print it and return
    call DispAnswer                 ;goes to DispAnswer
    call _SQROOT                    ;square root od op1(c^2 - b^2) ==> op1
    ld hl,String11                  ;string to print
    ld bc,256*25+0                  ;column 0, row 0
    ld (_penCol),bc                 ;loads c into _penCol
    call _vputs                     ;print it and return
    call DispAnswer                 ;goes to DispAnswer
    rst 08h                         ;op1 ==> op2
    call _rclY                      ;recall real variable y(b)
    rst 28h                         ;op1(b) * op2(a) ==> op1
    ld a,2                          ;loads a with 2
    call _setXXop2                  ;moves value @ a(2) to op2
    call _FPDIV                     ;op1(a * b) / op2(2) ==> op1
    ld hl,String9                   ;string to print
    ld bc,256*58+0                  ;column 0, row 0
    ld (_penCol),bc                 ;loads c into _penCol
    call _vputs                     ;print it and return
    call DispAnswer                 ;goes to DispAnswer
    call _rclY                      ;recall real variable y(b)
    ld hl,String12                  ;string to print
    ld bc,256*37+0                  ;column 0, row 0
    jr Display_c                    ;jump to Display_c

Solve_b:
    call ScreenDisplay              ;goes to ScreenDisplay
    call _rclX                      ;recall real variable x(a) to op1
    call _FPSQUARE                  ;op1(a) ^2 ==> op1
    call _op1toop4                  ;op1(a^2) ==> op4
    call _op6toop1                  ;op6(c) ==> op1
    call _FPSQUARE                  ;op1(c) ^2 ==> op1
    call _op4toop2                  ;op4(a^2) ==> op2
    call _FPSUB                     ;op1(c^2) - op2(a^2) ==> op1
    ld hl,String10                  ;string to print
    ld bc,256*37+4                  ;column 0, row 0
    ld (_penCol),bc                 ;loads c into _penCol
    call _vputs                     ;print it and return
    call DispAnswer                 ;goes to DispAnswer
    call _SQROOT                    ;square root of op1(c^2 - a^2) ==> op1
    ld hl,String12                  ;string to print
    ld bc,256*31+0                  ;column 0, row 0
    ld (_penCol),bc                 ;loads c into _penCol
    call _vputs                     ;print it and return
    call DispAnswer                 ;goes to DispAnswer
    rst 08h                         ;op1 ==> op2
    call _rclX                      ;recall real variable x(a) to op1
    rst 28h                         ;op1(a) * op2(b) ==> op1
    ld a,2                          ;loads a with 2
    call _setXXop2                  ;moves value @ a(2) to op2
    call _FPDIV                     ;op1(a * b) / op2(2) ==> op1
    ld hl,String9                   ;string to print
    ld bc,256*58+0                  ;column 0, row 0
    ld (_penCol),bc                 ;loads c into _penCol
    call _vputs                     ;print it and return
    call DispAnswer                 ;goes to DispAnswer
    call _rclX                      ;recall real variable x(a) to op1
    ld hl,String11                  ;string to print
    ld bc,256*25+0                  ;column 0, row 0
Display_c:
    ld (_penCol),bc                 ;loads c into _penCol
    call _vputs                     ;print it and return
    call DispAnswer                 ;goes to DispAnswer
    call _op6toop1                  ;op6(c) ==> op1
    ld d,6                          ;load d with 6
    call _ROUND                     ;round op1 to D(6) digits
    ld hl,String13                  ;string to print
    ld bc,256*43+0                  ;column 0, row 0
    ld (_penCol),bc                 ;loads c into _penCol
    call _vputs                     ;print it and return
    call DispAnswer                 ;goes to DispAnswer
    call _getkey                    ;aits for a key to be pressed
    jp Start                        ;jumps to Start

Solve_c:
    call ScreenDisplay              ;goes to ScreenDisplay
    call _rclX                      ;recall real variable x(a) to op1
    call _FPSQUARE                  ;op1(a) ^2 ==> op1
    call _op1toop4                  ;op1(a^2) ==> op4
    call _rclY                      ;recall real variable y(b) to op1
    call _FPSQUARE                  ;op1(b) ^2 ==> op1
    call _op4toop2                  ;op4(a^2) ==> op2
    call _FPADD                     ;op1(b^2) + op2(a^2) ==> op1
    ld hl,String10                  ;string to print
    ld bc,256*43+4                  ;column 0, row 0
    ld (_penCol),bc                 ;loads c into _penCol
    call _vputs                     ;print it and return
    call DispAnswer                 ;goes to DispAnswer
    call _SQROOT                    ;square root of op1(a^2 + b^2) ==> op1
    ld hl,String13                  ;string to print
    ld bc,256*37+0                  ;column 0, row 0
    ld (_penCol),bc                 ;loads c into _penCol
    call _vputs                     ;print it and return
    call DispAnswer                 ;goes to DispAnswer
    call _rclX                      ;recall real variable x(a) to op1
    rst 08h                         ;op1(a) ==> op2
    call _rclY                      ;recall real variable y(b) to op1
    rst 28h                         ;op1(b) * op2(a) ==> op1
    ld a,2                          ;loads a with 2
    call _setXXop2                  ;moves value @ a(2) to op2
    call _FPDIV                     ;op1(a * b) / op2(2) ==> op1
    ld hl,String9                   ;string to print
    ld bc,256*58+0                  ;column 0, row 0
    ld (_penCol),bc                 ;loads c into _penCol
    call _vputs                     ;print it and return
    call DispAnswer                 ;goes to DispAnswer
    call _rclX                      ;recall real variable x(a) to op1
    ld hl,String11                  ;string to print
    ld bc,256*25+0                  ;column 0, row 0
    ld (_penCol),bc                 ;loads c into _penCol
    call _vputs                     ;print it and return
    call DispAnswer                 ;goes to DispAnswer
    call _rclY                      ;recall real variable y(b) to op1
    ld hl,String12                  ;string to print
    ld bc,256*31+0                  ;column 0, row 0
    ld (_penCol),bc                 ;loads c into _penCol
    call _vputs                     ;print it and return
    call DispAnswer                 ;goes to DispAnswer
    call _getkey                    ;waits for a key to be pressed
    jp Start                        ;jumps to Start

ScreenDisplay:
    ld de,Picture                   ;load picture into de
    call decompV                    ;goes to decompV
    ld hl,String1                   ;string to print
    ld bc,256*1+0                   ;column 0, row 0
    ld (_penCol),bc                 ;loads c into _penCol
    call _vputs                     ;print it and return
    ld hl,String7                   ;string to print
    ld bc,256*13+0                  ;column 0, row 0
    ld (_penCol),bc                 ;loads c into _penCol
    call _vputs                     ;print it and return
    ret                             ;return to call

Negative:
    ld hl,(256*0)+2                 ;loads coordinates into hl
    ld (_curRow),hl                 ;loads _curRow with hl
    ld hl,String8                   ;loads hl with string
    call _puts                      ;print string
    call _getkey                    ;waits for a key to be pressed
    ld a,c                          ;loads a with c
    cp 1                            ;compares a with 1
    jp z,Input_a                    ;if 1 jump to Input_a
    cp 2                            ;compares a with 2
    jp z,Input_b                    ;if 2 jump to Input_b
    cp 3                            ;compares a with 3
    jp z,Input_c                    ;if 3 jump to Input_c

Text1:
    call _clrScrn                   ;clears lcd and graph screen
    call _homeup                    ;moves cursor to upper left
    ld hl,String7                   ;loads hl with string
    call _puts                      ;print string
    ld hl,(256*0)+1                 ;loads coordinates into hl
    ld (_curRow),hl                 ;loads _curRow with hl
    ret

Input:
    ld de,_ioprompt                 ;$c324 - string storage for display when prompte
    call _mov10b                    ;$427b - move 10 bytes from hl to de
    ld a,$0d                        ;type of input
                                    ;$0d - # value
                                    ;$0c - string
    ld (_asap_ind),a                ;$d623 - tell ti86 what kind to be inputted
    jp _exec_pg3                    ;$5714 - ti86 os input
                                    ;the number inputted is always stored to OP1
    ret                             ;return to call

DispAnswer:
    ld a,48                         ;loads a with 48
    call _formReal                  ;forms answer to real #
    ld hl,_OP3                      ;loads answer into hl
    call _vputs                     ;prints answer
    ret                             ;return to call

Back:
    ld hl,Prgm1-1                   ;loads hl with prgm name to execute
    rst 20h                         ;op1 = name of 2nd asm prog to call
    rst 10h                         ;call _findsym, see if variable exists
    jr c,Exit                       ;if not jump to Exit
    jp _exec_assembly               ;execute prgm in op1

Exit:
    res 3,(iy+5)                    ;reverts text back to black on white
    call _clrScrn                   ;clears lcd and graph screen
    call _homeup                    ;moves cursor to upper left
    ret                             ;return that exits the program

#include "Menu86.asm"
#include "BMP2ASM.asm"

String2:    .db "a",0
String3:    .db "b",0
String4:    .db "c",0
String5:    .db "Solve        Back"0
String6:    .db "Exit",0
String7:    .db "a",18,"+b",18,"=c",18,0
String8:    .db "No Negatives.",0
String9:    .db "area=     ",0
String10:   .db "=     ",16,0
String11:   .db "a=     ",0
String12:   .db "b=     ",0
String13:   .db "c=     ",0
E1:     .db "a=",0
E2:     .db "b=",0
E3:     .db "c=",0
Prgm1:  .db 5,"Belch"

Picture:
  .db $B7, $00, $FF, $B7, $00, $FF, $B7, $00, $B3, $01, $01, $02, $04, $08, $08, $10
  .db $3F, $B7, $00, $22, $01, $02, $02, $01, $B7, $00, $08, $01, $02, $04, $04, $08
  .db $10, $20, $20, $40, $80, $B7, $00, $07, $FF, $B7, $00, $22, $80, $01, $01, $82
  .db $04, $08, $10, $10, $20, $40, $80, $80, $B7, $00, $11, $FF, $00, $00, $01, $02
  .db $02, $01, $B7, $00, $13, $01, $02, $04, $04, $08, $10, $20, $20, $40, $80, $B7
  .db $00, $1C, $FF, $00, $00, $B7, $80, $04, $B7, $00, $08, $01, $02, $02, $04, $08
  .db $10, $10, $20, $40, $80, $80, $B7, $00, $26, $FF, $B7, $00, $0D, $B7, $80, $14
  .db $90, $98, $94, $94, $98, $B7, $80, $1A, $B7, $00, $08

.end
END